/* 
Unlimited Simulator is copyrighted (c) Bruno Barberi Gnecco, 1999, and
distributed under the GNU General Public License (GPL). The conditions can be
found in the file GPL, resident at the main directory of the distribution.
*/

/* This file is a well documented skeleton to create your own object.
All functions that are recognized are declared here. */

#include "client.h" /* as client.h defines things useful */

/* if some special version is required, uncomment the line below and fulfill
it correctly: */
/* #define NEEDVERSION	"" */

/* this structure will contain all relevant data for your client. Feel free
to rename it to whatever you want. */
struct myobj {
	/* some data */
};
typedef struct myobj MYOBJ;


/* this function initializes all data. Here you read the object's specs,
initialize functions, etc. This function is called once when the client is
loaded. Do not rename it. Note that OBJECT_UL *obj is already allocated. */
int initObject ( OBJECT_UL *obj ) {
	MYOBJ	*myo;
	
	/* check for UL version */
#ifdef NEEDVERSION
	if ( strcmp( NEEDVERSION, VERSION ) > 0 ) {
		fprintf( stderr, "This plugin needs Unlimited Simulator version %s or above",
				NEEDVERSION );
		return FATALERROR;
	}
#endif
	/* allocate memory */
	if ( !(myo = (MYOBJ *)malloc(sizeof(MYOBJ))) ) {
		fprintf( stderr, "Could not allocate memory for MYOBJ at initObject" );
		return FATALERROR; /* if something bad happens, return a
					FATALERROR. */
	}
	obj->struc = myo;

	/* allocate and initialize your own stuff */

	/* other miscellaneous initializations */

	return OK;
}

/* this function frees all data. It is called once when the simulation is
over, or the object is destroyed, to clean up everything. Do not rename it. */
void closeObject ( OBJECT_UL *obj ) {
	/* free general stuff that was allocated BY YOU */

	
	/* here you free all fields of client->struc */


	/* freeing the structure */
	free( obj->struc );
	
	/* the rest is done by the Unlimited Simulator itself. */
}

/* this funciton is the brain of your object. Here you decide what the object
should do, what happened to it, physics simulation, etc. You have access to
all functions and variables declared in headers of Unlimited Simulator, and
you can use external libraries too. */
int simulateObject ( OBJECT_UL *obj ) {

	return OK;
}
