/* 
Unlimited Simulator is copyrighted (c) Bruno Barberi Gnecco, 1999, and
distributed under the GNU General Public License (GPL). The conditions can be
found in the file GPL, resident at the main directory of the distribution.
*/
/* analytic geometry stuff
*/
#include "mathlib.h"

void initPlaneP ( PLANE_UL *p, POINT_UL *p1, POINT_UL *p2, POINT_UL *p3 ) {
        VECTOR_UL v1, v2;
	v1.x = p2->vect->x - p1->vect->x;
	v2.x = p3->vect->x - p1->vect->x;
	v1.y = p2->vect->y - p1->vect->y;
	v2.y = p3->vect->y - p1->vect->y;
	v1.z = p2->vect->z - p1->vect->z;
	v2.z = p3->vect->z - p1->vect->z;
	crossprodV ( &v1, &v2, &(p->normal) );
	normalizeV( &(p->normal) );

	p->dist = dotprodV( &(p->normal), p1->vect );
	
	p->a = p->normal.x;
	p->b = p->normal.y;
	p->c = p->normal.z;
	p->d = -(p->a*p1->vect->x + p->b*p1->vect->y + p->c*p1->vect->z);
	
	copyV( &p->p, p1->vect );
}

void initPlaneVD ( PLANE_UL *p, VECTOR_UL *v, double d ) {
	copyV( &(p->normal), v );
	normalizeV( &(p->normal) );
	p->dist = d;
	
	p->a = p->normal.x;
	p->b = p->normal.y;
	p->c = p->normal.z;
	
	/* missing the rest */
}

/* given a plane an a straight line in format v1+h.v2, find the intersection.
Returns 0 if no intersection found, 1 otherwise. */
int intPlaneLine ( PLANE_UL *p, VECTOR_UL *v1, VECTOR_UL *v2, VECTOR_UL *r ) {
	double		h, t;

	if ( (t = p->a*v2->x + p->b*v2->y + p->c*v2->z) == 0 ) /* determinant vanishes */
		return 0;

	h = -(p->d + p->a*v1->x + p->b*v1->y + p->c*v1->z)/t;
	r->x = v1->x + h*v2->x;
	r->y = v1->y + h*v2->y;
	r->z = v1->z + h*v2->z;
	return 1;
}
