/* 
Unlimited Simulator is copyrighted (c) Bruno Barberi Gnecco, 1999, and
distributed under the GNU General Public License (GPL). The conditions can be
found in the file GPL, resident at the main directory of the distribution.
*/
#ifdef CLIENT

#include "ulengine.h"

/* missing all light/color stuff */

/* this function calculates stuff like poly->flatcolor, etc, and should be 
called whenever light changes, deformation, etc. */
void updateAll ( Bool sphere, Bool color, Bool normals, Bool center ) {
	DOODAD_UL *tmp;
	for ( tmp = firstdoodad; tmp != NULL; tmp = tmp->next )
		updateDoodad( tmp, sphere, color, normals, center );
}

void updateDoodad ( DOODAD_UL *dood, Bool sphere, Bool color, Bool normals, 
		Bool center ) {
	int i;

	for ( i = 0; i < dood->npoly; i++ )
		updatePoly( dood->polygons[i], color, normals, center );
	
	/* bounding sphere? */
	if ( sphere == True )
		circSphere ( dood );
	centroid( dood, &dood->centroid );
}

void updatePoly ( POLY_UL *poly, Bool color, Bool normals, Bool center ) {
	uLong		r = 0, g = 0, b = 0, a = 0;
	ggi_color	c;
	VECTOR_UL	v1, v2;
	sInt 		i;

	for ( i = 0; i < poly->npoints; i++ ) {
		r += poly->color[i].r;
		g += poly->color[i].g;
		b += poly->color[i].b;
		a += poly->color[i].a;
		/* normals? */
		if ( normals == True ) {
			pointstoV( &poly->points[1], &poly->points[0], &v1 );
			pointstoV( &poly->points[2], &poly->points[0], &v2 );
			crossprodV( &v2, &v1, &poly->normal );
			normalizeV( &poly->normal );
		}
		if ( center == True )
			centerP( poly, &(poly->center) );
	}
		
	/* average color */
	c = RGBAtoColor( r/poly->npoints, g/poly->npoints, b/poly->npoints,
			a/poly->npoints );
	copyColor( poly->flatcolor, &c );

	/* now calculate light incidence */
}
#endif
